#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "App.h"

App *be_app;
int main(int argc, char *argv[])
{

  if (argc != 3) {
    fprintf(stderr,"usage: runme hostname port\n");
    fprintf(stderr,"example: runme icfp1.cse.ogi.edu 22101\n");
    exit(1);
  }
  be_app=new App();
  char *host;
  host=strdup(argv[1]);
  unsigned short int port;
  port=htons(atoi(argv[2]));
  be_app->Init(host,port);
  be_app->PrintToStream();
  be_app->Run();
  
  
return 0;
}
