#include "Target.h"
#include <stdio.h>
#include "App.h"
#include "RList.h"
Target::Target(int atype, int pos_x, int pos_y, int aid)
{
  type=atype;
  x=pos_x;
  y=pos_y;
  id=aid;
}

Target::~Target()
{
}

bool Target::Action(char *dest)
{
 /* char c=getchar();
  sprintf(dest,"1 Move %c\n",c);
  return true;
*/
  if(type==PUSH_NORTH){
    printf("PUSH NORTH\n");
    sprintf(dest,"5 Move N\n");
    be_app->targetList->RemoveItem(0);
    
    return true;
  }
  if(type==PUSH_SOUTH){
    printf("PUSH SOUTH\n");
    sprintf(dest,"5 Move S\n");
    be_app->targetList->RemoveItem(0);
    return true;
  }
  if(type==PUSH_EAST){
    printf("PUSH EAST\n");
    sprintf(dest,"5 Move E\n");
    be_app->targetList->RemoveItem(0);
    return true;
  }
  if(type==PUSH_WEST){
    printf("PUSH WEST\n");
    sprintf(dest,"5 Move W\n");
    be_app->targetList->RemoveItem(0);
    return true;
  }

  if(type==PICK){
    if(x==be_app->currentPlayer->x && y==be_app->currentPlayer->y){
      printf("Pick:Destination reached\n");
      sprintf(dest,"1 Pick %d\n",id);
      be_app->targetList->RemoveItem(0);
      return true;
    }else{
      be_app->targetList->AddItem(new Target(GOTO,x,y,id),0);
      sprintf(dest,"1 Pick %d\n",id);
      return true;
    }
  }

  if(type==DROP){
    if(x==be_app->currentPlayer->x && y==be_app->currentPlayer->y){
      printf("Srop:Destination reached\n");
      sprintf(dest,"1 Drop %d\n",id);
      be_app->targetList->RemoveItem(0);
      return true;
    }else{
      be_app->targetList->AddItem(new Target(GOTO,x,y,id),0);
      sprintf(dest,"1 Pick %d\n",id);
      return true;
    }
  }
  
  if(type==GOTO || type==KILL){
    be_app->Find.SetRows(be_app->width);
    be_app->Find.SetData(be_app->current_table);
    //be_app->Find.SetValid(be_app->Valid);
    //be_app->Find.SetCost(be_app->Cost);
    int x1=0,y1=0;
    int x2=0,y2=0;
    
    if(id<0){
       return false;
    }
    if(x==be_app->currentPlayer->x && y==be_app->currentPlayer->y ){
      printf("Destination reached: Waiting\n");
      sprintf(dest,"1 Pick 2000\n");
      id--;
      if(type==KILL)
	return true;
      return false;
    }
    
    if (be_app->Find.GeneratePath(
				  be_app->currentPlayer->x-1,
				  be_app->currentPlayer->y-1,
				  x-1,y-1))
      {
	//printf("Path found...from dest to start, nodes are:");
	
	_asNode *dest =  be_app->Find.GetBestNode();
	while (dest!=NULL) {
	  //printf("(%d, %d) ->", dest->x, dest->y);
	  /*count++;
	  if(count==1){
	    x1=dest->x;
	    y1=dest->y;
	    x2=x1;
	    y2=y2;
	  }
	  if(count==2){
	    x2=dest->x;
	    y2=dest->y;
	  }*/
	  if(dest->parent!=NULL){
	    x2=dest->x;
	    y2=dest->y;
	    x1=dest->parent->x;
	    y1=dest->parent->y;
	  }
	  dest = dest->parent;
	}
      }
    else
      {
	printf("Cannot find a path...");
	return false;
      }
    printf("\n(%d,%d)->(%d,%d)\n",x1,y1,x2,y2);
    sprintf(dest,"1 Pick 2000\n");
    if(x2-x1==1)
      sprintf(dest,"1 Move E\n");
    if(x2-x1==-1)
      sprintf(dest,"1 Move W\n");
    if(y2-y1==1)
      sprintf(dest,"1 Move N\n");
    if(y2-y1==-1)
      sprintf(dest,"1 Move S\n");
  }

  return true;
}

void Target::PrintToStream()
{
  if(type==DROP){
    printf("DROP at (%d,%d) package:%d\n",x,y,id);
  }else if(type==GOTO){
    printf("GO to (%d,%d)\n",x,y);
  }else if(type==PICK){
    printf("PICK to (%d,%d) package:%d\n",x,y,id);
  }else if(type==KILL){
    printf("KILL to (%d,%d)\n",x,y);
  }else if(type==PUSH_NORTH){
    printf("PUSH NORTH\n");
  }else if(type==PUSH_SOUTH){
    printf("PUSH SOUTH\n");
  }else if(type==PUSH_EAST){
    printf("PUSH EAST\n");
  }else if(type==PUSH_WEST){
    printf("PUSH WEST\n");
  }

  else{
      printf("Bad Target\n");
  }
}

bool Target::hasSameTarget(Target *t){
  if(type==t->type && x==t->x && y==t->y && id==t->id){
    return true;
  }
  return false;
}
